%%% compute m1 using Monte Carlo %%%
m1      =   zeros(1+Nr,1);

disp('Solve for m1 through Monte Carlo:');
for ii=1:(Nr+1)
    disp(['Progress: ',num2str(ii),'/ ',num2str(Nr+1)]);
    x0      =   rmin+dr*(ii-1);
    x0p     =   round((x0-rmin0)/dr0)+1;
    %create the CIR process%
    mdl     =   cir(kappa,theta,sigma,'StartState',x0);
    Paths   =   simByEuler(mdl,M,'NTRIALS',Npath,'DeltaTime',dt,'Antithetic',true);
    Paths   =   real(Paths);
    %monte carlo method to compute u and v%
    usum    =   0;
    vsum    =   0;
    for ipath=1:Npath
        dft         =   1;
        runningInt  =   0;
        uintgd      =   zeros(M+1,1);
        vintgd      =   zeros(M+1,1);
        vintgd(1)   =   p(0,m0(x0p))+(m0(x0p)-x0)*pm(0,m0(x0p));
        for l=2:(M+1)
            thist      =   dt*(l-1);
            dft     =   dft*exp(dt*(-Paths(l-1,1,ipath)-lambda));
            runningInt  =   runningInt+dt*g1(m0(x0p),m0(min(Nr0+1,round(max(dr0,Paths(l-1,1,ipath))/dr0))));
            uintgd(l)   =   dft*runningInt*(m0(x0p)-Paths(l,1,ipath))*p(thist,m0(x0p));
            vintgd(l)   =   dft*(p(thist,m0(x0p))+(m0(x0p)-Paths(l,1,ipath))*pm(thist,m0(x0p)));
        end
        usum    =   usum+dt*trapz(uintgd);
        vsum    =   vsum+dt*trapz(vintgd);
    end
    m1(ii)=usum/vsum;
end
