function [ bc ] = fbc2( theta,kappa,sigma,lambda,x,T,M )
bc          =   zeros(2,M+1);
dt          =   T/M;
alpha       =   0.5*sqrt(kappa*kappa+2*sigma*sigma);
C           =   @(u) sinh(alpha*u)/(alpha*cosh(alpha*u)+0.5*kappa*sinh(alpha*u));
A           =   @(u) -2*kappa*theta/(sigma*sigma)*log(alpha*exp(0.5*kappa*u)/(alpha*cosh(alpha*u)+0.5*kappa*sinh(alpha*u)));
for i = 1:M+1
    tl = dt*(i-1);
    bcexp = @(u) exp(-x.*C(u-tl)-A(u-tl)-lambda*(u-tl));
    bc(2,i) = integral(bcexp,tl,T,'ArrayValued',true);
    bc(1,i) = 1-lambda*bc(2,i)-exp(-x.*C(T-tl)-A(T-tl)-lambda*(T-tl));
end
end

