
%initialize m
m       =   zeros(Nr+1,K+1);
%%% a random initial guess %%%
%rng('default');
%imodel=cir(0.5, 0.08, 0.1,'StartState',0.05);
%m(:,1) = imodel.simByEuler(Nr, 'DeltaTime',dr,'nTrials', 1);
%%% ---------------------- %%%

m(:,1)  =   0.05*(1+sin((0:1:Nr)/dr));

%create the drift and diffusion rates
%F       =   drift([kappa*theta;0],diag([-kappa;muh]));
%G       =   diffusion([0.5;1],diag([sigmar;sigmah]));

for k=1:K
    for i=1:(Nr+1)
        disp(['k=',num2str(k),', i=',num2str(i),'. ']);
        r0      =   rmin+dr*(i-1);
        %create the 1-d CIR process
        mdl     =   cir(kappa,theta,sigma,'StartState',r0);
        %simulate the paths of the state process r
        Paths   =   simByEuler(mdl,M,'NTRIALS',Npath,'DeltaTime',dt,'Antithetic',true);
        Paths   =   real(Paths);
        %monte carlo method to compute u and v
        usum    =   0;
        vsum    =   0;
        for ipath=1:Npath
            dft     =   1;
            uintgd  =   zeros(M+1,1);
            vintgd  =   zeros(M+1,1);
            uintgd(1)   =   r0;
            vintgd(1)   =   1;
            for l=2:(M+1)
                ut      =   dt*(l-1);
                dft     =   dft*exp(dt*(-Paths(l-1,1,ipath)-gamma_e(Paths(l-1,1,ipath),m(i,k),m(min(Nr,max(1,round(Paths(l-1,1,ipath)/dr))),k))));
                uintgd(l)   =   dft*(p(ut,m(i,k))*Paths(l,1,ipath));
                vintgd(l)   =   dft*p(ut,m(i,k));
            end
            usum    =   usum+dt*trapz(uintgd);
            vsum    =   vsum+dt*trapz(vintgd);
        end
        m(i,k+1)=usum/vsum;     
    end
end
m=real(m);
figure;
hold all;
grid off;
plot(rmin:dr:rmax,100*m(:,1),':k','LineWidth',1.0);
plot(rmin:dr:rmax,100*m(:,3),'--k','LineWidth',1.0);
plot(rmin:dr:rmax,100*m(:,6),'-.k','LineWidth',1.0);
plot(rmin:dr:rmax,100*m(:,11),'-k','LineWidth',1.0);
xlabel('r');
ylabel('percent');
legend('initial guess','2  iterations','5  iterations','10 iterations','Location','northwest');
hold off;